PropertyFile (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.taskdefs.optional, class: PropertyFile

# Class PropertyFile

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.Task
org.apache.tools.ant.taskdefs.optional.PropertyFile

All Implemented Interfaces:
  `Cloneable`

public class PropertyFile extends Task
Modifies settings in a property file.

The following is an example of its usage:

       <target name="setState">
         <property
           name="header"
           value="##Generated file - do not modify!"/>
         <propertyfile file="apropfile.properties" comment="${header}">
           <entry key="product.version.major" type="int"  value="5"/>
           <entry key="product.version.minor" type="int"  value="0"/>
           <entry key="product.build.major"   type="int"  value="0" />
           <entry key="product.build.minor"   type="int"  operation="+"/>
           <entry key="product.build.date"    type="date" value="now"/>
           <entry key="intSet" type="int" operation="=" value="681"/>
           <entry key="intDec" type="int" operation="-"/>
           <entry key="StringEquals" type="string" value="testValue"/>
        </propertyfile>
      </target>

The <propertyfile> task must have:

- file

Other parameters are:

- comment
- key
- operation
- type
- value (the final four being eliminated shortly)

The <entry> task must have:

- key

Other parameters are:

- operation
- type
- value
- default
- unit

If type is unspecified, it defaults to string.

Parameter values:

operation:
  - "=" (set -- default)
  - "-" (dec)
  - "+" (inc)
type:
  - "int"
  - "date"
  - "string"
value:
  - holds the default value, if the property was not found in property file
  - "now" In case of type "date", the value "now" will be replaced by the current date/time and used even if a valid date was found in the property file.

String property types can only use the "=" operation. Int property types can only use the "=", "-" or "+" operations.

The message property is used for the property file header, with "\\" being a newline delimiter character.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `PropertyFile.Entry`
  Instance of this class represents nested elements of a task propertyfile.
  `static class`
  `PropertyFile.Unit`
  Borrowed from Tstamp

- ## Field Summary

  ### Fields inherited from class Task

  `target, taskName, taskType, wrapper`
  Modifier and Type
  Field
  Description
  `protected Target`
  `target`
  Deprecated.
  since 1.6.x.
  `protected String`
  `taskName`
  Deprecated.
  since 1.6.x.
  `protected String`
  `taskType`
  Deprecated.
  since 1.6.x.
  `protected RuntimeConfigurable`
  `wrapper`
  Deprecated.
  since 1.6.x.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PropertyFile()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `PropertyFile.Entry`
  `createEntry()`
  The entry nested element.
  `void`
  `execute()`
  Execute the task.
  `void`
  `setComment(String hdr)`
  optional header comment for the file
  `void`
  `setFile(File file)`
  Location of the property file to be edited; required.
  `void`
  `setJDKProperties(boolean val)`
  optional flag to use original Java properties (as opposed to layout preserving properties)

  ### Methods inherited from class Task

  `bindToOwner, getOwningTarget, getRuntimeConfigurableWrapper, getTaskName, getTaskType, getWrapper, handleErrorFlush, handleErrorOutput, handleFlush, handleInput, handleOutput, init, isInvalid, log, log, log, log, maybeConfigure, perform, reconfigure, setOwningTarget, setRuntimeConfigurableWrapper, setTaskName, setTaskType`
  Modifier and Type
  Method
  Description
  `final void`
  `bindToOwner(Task owner)`
  Bind a task to another; use this when configuring a newly created task to do work on behalf of another.
  `Target`
  `getOwningTarget()`
  Returns the container target of this task.
  `RuntimeConfigurable`
  `getRuntimeConfigurableWrapper()`
  Returns the wrapper used for runtime configuration.
  `String`
  `getTaskName()`
  Returns the name to use in logging messages.
  `String`
  `getTaskType()`
  Return the type of task.
  `protected RuntimeConfigurable`
  `getWrapper()`
  Return the runtime configurable structure for this task.
  `protected void`
  `handleErrorFlush(String output)`
  Handles an error line by logging it with the WARN priority.
  `protected void`
  `handleErrorOutput(String output)`
  Handles an error output by logging it with the WARN priority.
  `protected void`
  `handleFlush(String output)`
  Handles output by logging it with the INFO priority.
  `protected int`
  `handleInput(byte[] buffer, int offset, int length)`
  Handle an input request by this task.
  `protected void`
  `handleOutput(String output)`
  Handles output by logging it with the INFO priority.
  `void`
  `init()`
  Called by the project to let the task initialize properly.
  `protected final boolean`
  `isInvalid()`
  Has this task been marked invalid?
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `log(String msg, Throwable t, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `log(Throwable t, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `maybeConfigure()`
  Configures this task - if it hasn't been done already.
  `final void`
  `perform()`
  Performs this task if it's still valid, or gets a replacement version and performs that otherwise.
  `void`
  `reconfigure()`
  Force the task to be reconfigured from its RuntimeConfigurable.
  `void`
  `setOwningTarget(Target target)`
  Sets the target container of this task.
  `void`
  `setRuntimeConfigurableWrapper(RuntimeConfigurable wrapper)`
  Sets the wrapper to be used for runtime configuration.
  `void`
  `setTaskName(String name)`
  Sets the name to use in logging messages.
  `void`
  `setTaskType(String type)`
  Sets the name with which the task has been invoked.

  ### Methods inherited from class ProjectComponent

  `clone, getDescription, getLocation, getProject, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `Object`
  `clone()`
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### PropertyFile

    public PropertyFile()

- ## Method Details

  - ### execute

    public void execute() throws BuildException
    Execute the task.
    Overrides:
      `execute` in class `Task`
    Throws:
      `BuildException` - on error.

  - ### createEntry

    public PropertyFile.Entry createEntry()
    The entry nested element.
    Returns:
      an entry nested element to be configured.

  - ### setFile

    public void setFile(File file)
    Location of the property file to be edited; required.
    Parameters:
      `file` - the property file.

  - ### setComment

    public void setComment(String hdr)
    optional header comment for the file
    Parameters:
      `hdr` - the string to use for the comment.

  - ### setJDKProperties

    public void setJDKProperties(boolean val)
    optional flag to use original Java properties (as opposed to layout preserving properties)
    Parameters:
      `val` - boolean